<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>CoglDisplay: Setup a display pipeline</title>
<meta name="generator" content="DocBook XSL Stylesheets V1.78.1">
<link rel="home" href="index.html" title="Cogl 2.0 Reference Manual">
<link rel="up" href="cogl-context-apis.html" title="Setting Up A Drawing Context">
<link rel="prev" href="cogl-2.0-experimental-CoglOnscreenTemplate---Describe-a-template-for-onscreen-framebuffers.html" title="CoglOnscreenTemplate: Describe a template for onscreen framebuffers">
<link rel="next" href="cogl-2.0-experimental-The-Top-Level-Context.html" title="The Top-Level Context">
<meta name="generator" content="GTK-Doc V1.18.1 (XML mode)">
<link rel="stylesheet" href="style.css" type="text/css">
</head>
<body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF">
<table class="navigation" id="top" width="100%" summary="Navigation header" cellpadding="2" cellspacing="2">
<tr valign="middle">
<td><a accesskey="p" href="cogl-2.0-experimental-CoglOnscreenTemplate---Describe-a-template-for-onscreen-framebuffers.html"><img src="left.png" width="24" height="24" border="0" alt="Prev"></a></td>
<td><a accesskey="u" href="cogl-context-apis.html"><img src="up.png" width="24" height="24" border="0" alt="Up"></a></td>
<td><a accesskey="h" href="index.html"><img src="home.png" width="24" height="24" border="0" alt="Home"></a></td>
<th width="100%" align="center">Cogl 2.0 Reference Manual</th>
<td><a accesskey="n" href="cogl-2.0-experimental-The-Top-Level-Context.html"><img src="right.png" width="24" height="24" border="0" alt="Next"></a></td>
</tr>
<tr><td colspan="5" class="shortcuts">
<a href="#cogl-2.0-experimental-CoglDisplay---Setup-a-display-pipeline.synopsis" class="shortcut">Top</a>
                   | 
                  <a href="#cogl-2.0-experimental-CoglDisplay---Setup-a-display-pipeline.description" class="shortcut">Description</a>
</td></tr>
</table>
<div class="refentry">
<a name="cogl-2.0-experimental-CoglDisplay---Setup-a-display-pipeline"></a><div class="titlepage"></div>
<div class="refnamediv"><table width="100%"><tr>
<td valign="top">
<h2><span class="refentrytitle"><a name="cogl-2.0-experimental-CoglDisplay---Setup-a-display-pipeline.top_of_page"></a>CoglDisplay: Setup a display pipeline</span></h2>
<p>CoglDisplay: Setup a display pipeline — Common aspects of a display pipeline</p>
</td>
<td valign="top" align="right"></td>
</tr></table></div>
<div class="refsynopsisdiv">
<a name="cogl-2.0-experimental-CoglDisplay---Setup-a-display-pipeline.synopsis"></a><h2>Synopsis</h2>
<pre class="synopsis">                    <a class="link" href="cogl-2.0-experimental-CoglDisplay---Setup-a-display-pipeline.html#CoglDisplay" title="CoglDisplay">CoglDisplay</a>;
<a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglBool" title="CoglBool"><span class="returnvalue">CoglBool</span></a>            <a class="link" href="cogl-2.0-experimental-CoglDisplay---Setup-a-display-pipeline.html#cogl-is-display" title="cogl_is_display ()">cogl_is_display</a>                     (<em class="parameter"><code><span class="type">void</span> *object</code></em>);

<a class="link" href="cogl-2.0-experimental-CoglDisplay---Setup-a-display-pipeline.html#CoglDisplay" title="CoglDisplay"><span class="returnvalue">CoglDisplay</span></a> *       <a class="link" href="cogl-2.0-experimental-CoglDisplay---Setup-a-display-pipeline.html#cogl-display-new" title="cogl_display_new ()">cogl_display_new</a>                    (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a> *renderer</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreenTemplate---Describe-a-template-for-onscreen-framebuffers.html#CoglOnscreenTemplate" title="CoglOnscreenTemplate"><span class="type">CoglOnscreenTemplate</span></a> *onscreen_template</code></em>);
<a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="returnvalue">CoglRenderer</span></a> *      <a class="link" href="cogl-2.0-experimental-CoglDisplay---Setup-a-display-pipeline.html#cogl-display-get-renderer" title="cogl_display_get_renderer ()">cogl_display_get_renderer</a>           (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglDisplay---Setup-a-display-pipeline.html#CoglDisplay" title="CoglDisplay"><span class="type">CoglDisplay</span></a> *display</code></em>);
<a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglBool" title="CoglBool"><span class="returnvalue">CoglBool</span></a>            <a class="link" href="cogl-2.0-experimental-CoglDisplay---Setup-a-display-pipeline.html#cogl-display-setup" title="cogl_display_setup ()">cogl_display_setup</a>                  (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglDisplay---Setup-a-display-pipeline.html#CoglDisplay" title="CoglDisplay"><span class="type">CoglDisplay</span></a> *display</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Exception-handling.html#CoglError" title="CoglError"><span class="type">CoglError</span></a> **error</code></em>);

<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-CoglDisplay---Setup-a-display-pipeline.html#cogl-gdl-display-set-plane" title="cogl_gdl_display_set_plane ()">cogl_gdl_display_set_plane</a>          (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglDisplay---Setup-a-display-pipeline.html#CoglDisplay" title="CoglDisplay"><span class="type">CoglDisplay</span></a> *display</code></em>,
                                                         <em class="parameter"><code><span class="type">gdl_plane_id_t</span> plane</code></em>);

<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-CoglDisplay---Setup-a-display-pipeline.html#cogl-wayland-display-set-compositor-display" title="cogl_wayland_display_set_compositor_display ()">cogl_wayland_display_set_compositor_display</a>
                                                        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglDisplay---Setup-a-display-pipeline.html#CoglDisplay" title="CoglDisplay"><span class="type">CoglDisplay</span></a> *display</code></em>,
                                                         <em class="parameter"><code><span class="type">struct wl_display</span> *wayland_display</code></em>);
</pre>
</div>
<div class="refsect1">
<a name="cogl-2.0-experimental-CoglDisplay---Setup-a-display-pipeline.description"></a><h2>Description</h2>
<p>
The basic intention for this object is to let the application
configure common display preferences before creating a context, and
there are a few different aspects to this...
</p>
<p>
Firstly there are options directly relating to the physical display
pipeline that is currently being used including the digital to
analogue conversion hardware and the screens the user sees.
</p>
<p>
Another aspect is that display options may constrain or affect how
onscreen framebuffers should later be configured. The original
rationale for the display object in fact was to let us handle GLX
and EGLs requirements that framebuffers must be "compatible" with
the config associated with the current context meaning we have to
force the user to describe how they would like to create their
onscreen windows before we can choose a suitable fbconfig and
create a GLContext.
</p>
</div>
<div class="refsect1">
<a name="cogl-2.0-experimental-CoglDisplay---Setup-a-display-pipeline.details"></a><h2>Details</h2>
<div class="refsect2">
<a name="CoglDisplay"></a><h3>CoglDisplay</h3>
<pre class="programlisting">typedef struct _CoglDisplay CoglDisplay;</pre>
</div>
<hr>
<div class="refsect2">
<a name="cogl-is-display"></a><h3>cogl_is_display ()</h3>
<pre class="programlisting"><a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglBool" title="CoglBool"><span class="returnvalue">CoglBool</span></a>            cogl_is_display                     (<em class="parameter"><code><span class="type">void</span> *object</code></em>);</pre>
<p>
Gets whether the given object references a <a class="link" href="cogl-2.0-experimental-CoglDisplay---Setup-a-display-pipeline.html#CoglDisplay" title="CoglDisplay"><span class="type">CoglDisplay</span></a>.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>object</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-The-Object-Interface.html#CoglObject" title="CoglObject"><span class="type">CoglObject</span></a> pointer</td>
</tr>
<tr>
<td><p><span class="term"><span class="emphasis"><em>Returns</em></span> :</span></p></td>
<td>
<a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#TRUE:CAPS"><code class="literal">TRUE</code></a> if the object references a <a class="link" href="cogl-2.0-experimental-CoglDisplay---Setup-a-display-pipeline.html#CoglDisplay" title="CoglDisplay"><span class="type">CoglDisplay</span></a>
and <a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#FALSE:CAPS"><code class="literal">FALSE</code></a> otherwise.</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.10</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-display-new"></a><h3>cogl_display_new ()</h3>
<pre class="programlisting"><a class="link" href="cogl-2.0-experimental-CoglDisplay---Setup-a-display-pipeline.html#CoglDisplay" title="CoglDisplay"><span class="returnvalue">CoglDisplay</span></a> *       cogl_display_new                    (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a> *renderer</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreenTemplate---Describe-a-template-for-onscreen-framebuffers.html#CoglOnscreenTemplate" title="CoglOnscreenTemplate"><span class="type">CoglOnscreenTemplate</span></a> *onscreen_template</code></em>);</pre>
<p>
Explicitly allocates a new <a class="link" href="cogl-2.0-experimental-CoglDisplay---Setup-a-display-pipeline.html#CoglDisplay" title="CoglDisplay"><span class="type">CoglDisplay</span></a> object to encapsulate the
common state of the display pipeline that applies to the whole
application.
</p>
<p>
</p>
<div class="note" style="margin-left: 0.5in; margin-right: 0.5in;">
<h3 class="title">Note</h3>Many applications don't need to explicitly use
<a class="link" href="cogl-2.0-experimental-CoglDisplay---Setup-a-display-pipeline.html#cogl-display-new" title="cogl_display_new ()"><code class="function">cogl_display_new()</code></a> and can just jump straight to <a class="link" href="cogl-2.0-experimental-The-Top-Level-Context.html#cogl-context-new" title="cogl_context_new ()"><code class="function">cogl_context_new()</code></a>
and pass a <a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#NULL:CAPS"><code class="literal">NULL</code></a> display argument so Cogl will automatically
connect and setup a renderer and display.</div>
<p>
</p>
<p>
A <em class="parameter"><code>display</code></em> can only be made for a specific choice of renderer which
is why this takes the <em class="parameter"><code>renderer</code></em> argument.
</p>
<p>
A common use for explicitly allocating a display object is to
define a template for allocating onscreen framebuffers which is
what the <em class="parameter"><code>onscreen_template</code></em> argument is for, or alternatively
you can use <code class="function">cogl_display_set_onscreen_template()</code>.
</p>
<p>
When a display is first allocated via <a class="link" href="cogl-2.0-experimental-CoglDisplay---Setup-a-display-pipeline.html#cogl-display-new" title="cogl_display_new ()"><code class="function">cogl_display_new()</code></a> it is in a
mutable configuration mode. It's designed this way so we can
extend the apis available for configuring a display without
requiring huge numbers of constructor arguments.
</p>
<p>
When you have finished configuring a display object you can
optionally call <a class="link" href="cogl-2.0-experimental-CoglDisplay---Setup-a-display-pipeline.html#cogl-display-setup" title="cogl_display_setup ()"><code class="function">cogl_display_setup()</code></a> to explicitly apply the
configuration and check for errors. Alternaitvely you can pass the
display to <a class="link" href="cogl-2.0-experimental-The-Top-Level-Context.html#cogl-context-new" title="cogl_context_new ()"><code class="function">cogl_context_new()</code></a> and Cogl will implicitly apply your
configuration but if there are errors then the application will
abort with a message. For simple applications with no fallback
options then relying on the implicit setup can be fine.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>renderer</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>onscreen_template</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-CoglOnscreenTemplate---Describe-a-template-for-onscreen-framebuffers.html#CoglOnscreenTemplate" title="CoglOnscreenTemplate"><span class="type">CoglOnscreenTemplate</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><span class="emphasis"><em>Returns</em></span> :</span></p></td>
<td>A newly allocated <a class="link" href="cogl-2.0-experimental-CoglDisplay---Setup-a-display-pipeline.html#CoglDisplay" title="CoglDisplay"><span class="type">CoglDisplay</span></a>
object in a mutable configuration mode. <span class="annotation">[<acronym title="Free data after the code is done."><span class="acronym">transfer full</span></acronym>]</span>
</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.10</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-display-get-renderer"></a><h3>cogl_display_get_renderer ()</h3>
<pre class="programlisting"><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="returnvalue">CoglRenderer</span></a> *      cogl_display_get_renderer           (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglDisplay---Setup-a-display-pipeline.html#CoglDisplay" title="CoglDisplay"><span class="type">CoglDisplay</span></a> *display</code></em>);</pre>
<p>
Queries the <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a> associated with the given <em class="parameter"><code>display</code></em>.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>display</code></em> :</span></p></td>
<td>a <a class="link" href="cogl-2.0-experimental-CoglDisplay---Setup-a-display-pipeline.html#CoglDisplay" title="CoglDisplay"><span class="type">CoglDisplay</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><span class="emphasis"><em>Returns</em></span> :</span></p></td>
<td>The associated <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a>. <span class="annotation">[<acronym title="Don't free data after the code is done."><span class="acronym">transfer none</span></acronym>]</span>
</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.10</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-display-setup"></a><h3>cogl_display_setup ()</h3>
<pre class="programlisting"><a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglBool" title="CoglBool"><span class="returnvalue">CoglBool</span></a>            cogl_display_setup                  (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglDisplay---Setup-a-display-pipeline.html#CoglDisplay" title="CoglDisplay"><span class="type">CoglDisplay</span></a> *display</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Exception-handling.html#CoglError" title="CoglError"><span class="type">CoglError</span></a> **error</code></em>);</pre>
<p>
Explicitly sets up the given <em class="parameter"><code>display</code></em> object. Use of this api is
optional since Cogl will internally setup the display if not done
explicitly.
</p>
<p>
When a display is first allocated via <a class="link" href="cogl-2.0-experimental-CoglDisplay---Setup-a-display-pipeline.html#cogl-display-new" title="cogl_display_new ()"><code class="function">cogl_display_new()</code></a> it is in a
mutable configuration mode. This allows us to extend the apis
available for configuring a display without requiring huge numbers
of constructor arguments.
</p>
<p>
Its possible to request a configuration that might not be
supportable on the current system and so this api provides a means
to apply the configuration explicitly but if it fails then an
exception will be returned so you can handle the error gracefully
and perhaps fall back to an alternative configuration.
</p>
<p>
If you instead rely on Cogl implicitly calling <a class="link" href="cogl-2.0-experimental-CoglDisplay---Setup-a-display-pipeline.html#cogl-display-setup" title="cogl_display_setup ()"><code class="function">cogl_display_setup()</code></a>
for you then if there is an error with the configuration you won't
get an opportunity to handle that and the application may abort
with a message.  For simple applications that don't have any
fallback options this behaviour may be fine.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>display</code></em> :</span></p></td>
<td>a <a class="link" href="cogl-2.0-experimental-CoglDisplay---Setup-a-display-pipeline.html#CoglDisplay" title="CoglDisplay"><span class="type">CoglDisplay</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>error</code></em> :</span></p></td>
<td>return location for a <a class="link" href="cogl-2.0-experimental-Exception-handling.html#CoglError" title="CoglError"><span class="type">CoglError</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><span class="emphasis"><em>Returns</em></span> :</span></p></td>
<td>Returns <a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#TRUE:CAPS"><code class="literal">TRUE</code></a> if there was no error, else it returns
<a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#FALSE:CAPS"><code class="literal">FALSE</code></a> and returns an exception via <em class="parameter"><code>error</code></em>.</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.10</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-gdl-display-set-plane"></a><h3>cogl_gdl_display_set_plane ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_gdl_display_set_plane          (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglDisplay---Setup-a-display-pipeline.html#CoglDisplay" title="CoglDisplay"><span class="type">CoglDisplay</span></a> *display</code></em>,
                                                         <em class="parameter"><code><span class="type">gdl_plane_id_t</span> plane</code></em>);</pre>
<p>
Request that Cogl output to a specific GDL overlay <em class="parameter"><code>plane</code></em>.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>display</code></em> :</span></p></td>
<td>a <a class="link" href="cogl-2.0-experimental-CoglDisplay---Setup-a-display-pipeline.html#CoglDisplay" title="CoglDisplay"><span class="type">CoglDisplay</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>plane</code></em> :</span></p></td>
<td>the GDL plane id</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.10</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-wayland-display-set-compositor-display"></a><h3>cogl_wayland_display_set_compositor_display ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_wayland_display_set_compositor_display
                                                        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglDisplay---Setup-a-display-pipeline.html#CoglDisplay" title="CoglDisplay"><span class="type">CoglDisplay</span></a> *display</code></em>,
                                                         <em class="parameter"><code><span class="type">struct wl_display</span> *wayland_display</code></em>);</pre>
<p>
Informs Cogl of a compositor's Wayland display pointer. This
enables Cogl to register private wayland extensions required to
pass buffers between the clients and compositor.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>display</code></em> :</span></p></td>
<td>a <a class="link" href="cogl-2.0-experimental-CoglDisplay---Setup-a-display-pipeline.html#CoglDisplay" title="CoglDisplay"><span class="type">CoglDisplay</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>wayland_display</code></em> :</span></p></td>
<td>A compositor's Wayland display pointer</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.10</p>
<p class="stability">Stability Level: Unstable</p>
</div>
</div>
</div>
<div class="footer">
<hr>
          Generated by GTK-Doc V1.18.1</div>
</body>
</html>